# coding: utf-8
"""
    OurPipApi.py

    Copyright (c) 2018, Masatsuyo Takahashi, KEK-PF
"""

import re
import fnmatch
import os
import subprocess
from packaging import version
from pip_api import installed_distributions
# from pip_api._call import call
from Console import reset_text_color

def decode_robust(b):
    try:
        s = b.decode('utf-8', errors='ignore')
    except Exception as exc:
        s = str(exc)
    return s

def call(*args):
    python_location = os.environ.get('PIPAPI_PYTHON_LOCATION', 'python')
    result = subprocess.check_output(
        [python_location, '-m', 'pip'] + list(args)
    )
    return decode_robust(result)

shown_line_re = re.compile(r'^(\S+):\s*(.*)$')
searched_line_re = re.compile(r'^(\S+)')
installed_line_re = re.compile(r'^\s+INSTALLED:\s+(\S+)\s*(\(latest\))?')
latest_line_re = re.compile(r'^\s+LATEST:\s+(.+)')

def update_all_packages(restrict=None):
    if restrict is None:
        restrict_re = None
    else:
        restrict_re = re.compile(fnmatch.translate(restrict))

    for k, v in installed_distributions().items():
        if restrict_re is None:
            pass
        else:
            if restrict_re.match(k):
                pass
            else:
                continue
        reset_text_color()
        print(k)
        shown = call('show', k)
        # print(shown)
        for line in shown.split('\r\n'):
            m = shown_line_re.match(line)
            if m:
                key = m.group(1)
                value = m.group(2)
                if key == 'Name':
                    assert k == value
                    # print("'%s'" % value)
                elif key == 'Version':
                    print(k, value)
        try:
            searched = call('search', k)
        except Exception as exc:
            print(exc)
            print('pip search failed for', k)
            searched = ''
        # print(searched)
        this_line_no = None
        verified = False
        for n, line in enumerate(searched.split('\r\n')):
            m = searched_line_re.search(line)
            if m:
                name = m.group(1)
                if name == k:
                    # print(line)
                    this_line_no = n
            if this_line_no is not None and n > this_line_no and n < this_line_no + 3:
                print(line)
                m = installed_line_re.match(line)
                if m:
                    installed_version = m.group(1)
                    installed_latest = m.group(2)
                    # print(installed_version, installed_latest)
                    if installed_latest is not None:
                        verified = True
                        break
                m = latest_line_re.match(line)
                if m:
                    latest_version = m.group(1)
                    print(installed_version, latest_version)
                    if version.parse(installed_version) < version.parse(latest_version):
                        print('need update')
                        print('pip install %s -U' % k)
                        try:
                            install_log = call('install', k, '-U')
                            print(install_log)
                            if install_log.lower().find('error') > 0:
                                exit()
                        except Exception as exc:
                            print(exc)
                            print('pip install failed for', k)
                    else:
                        print('no need')
                    verified = True
                    break

        # assert verified
        if not verified:
            print( k, 'is not verified. need to update manually.' )
